variables:
  appname: 'stackapp'
  appver: 'v2'
  artficatreporeg: "https://ashwinbittu.jfrog.io"
  artifactrepo: "/stackapp-repo"
  artifactrepocreds: 'jfrog-artifact-saas'
  infracreatemode: 'false'    

before_script:
    - export env=$APP_ENV_DEV
    - export appname=$app_name_stackapp   
    - export targetRegion=$AWS_DEFAULT_REGION   
    - export AWS_REGION=$AWS_DEFAULT_REGION 
    
stages:   
    - setting-env-vars     
    - build  
    - unit-testing
    - integration-testing  
    - checkstyle-code-analysis
    - sonarqube-code-analysis
    - image-upload-to-artifactory    
    - baking-amis   
    - network-infra-creation 
    - application-infra-creation 
    - database-infra-creation
    - caching-infra-creation
    - messaging-infra-creation  
    - route53-infra-creation 
    - all-infra-destroy     

Build:
    stage: build
    image: maven:3.6-jdk-8
    rules:
        - if: '$infracreatemode == "true"'       
    script:                   
        - echo "MVN Build" 
        - mvn clean install -DskipTests
    artifacts:
        paths:
            - "target/*.war"

Unit Testing:
    stage: unit-testing
    image: maven:3.6-jdk-8
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Unit Testing"
        - mvn test

Integration Testing:
    stage: integration-testing
    image: maven:3.6-jdk-8
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Integration Testing"
        - mvn verify -DskipUnitTests

Checkstyle Code Analysis:
    stage: checkstyle-code-analysis
    image: maven:3.6-jdk-8
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Checkstyle Code Analysis"
        - mvn checkstyle:checkstyle
    after_script:
         - echo "Generated Analysis Result"

#Sonarqube Code Analysis:
#    stage: sonarqube-code-analysis
#    rules:
#        - if: '$infracreatemode == "true"'    
#    script:
#        - echo "Testing"
#        - test -f "build/info.txt"

Image Upload to Artifactory:
    stage: image-upload-to-artifactory
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'            
    script:
        #- curl -fL https://getcli.jfrog.io | sh
        #- ./jfrog config add jfrogsrv --artifactory-url $artficatreporeg  --access-token $ART_TOKEN --interactive=false
        #- ./jfrog config use jfrogsrv        
        - echo "Image Upload to Artifactory"
        #- ./jfrog rt u target/$appname-$appver.war" stackapp-repo/$CI_PIPELINE_ID --recursive=false   
        - curl -H "X-JFrog-Art-Api:$ART_TOKEN" -T target/$appname-$appver.war "$artficatreporeg/artifactory$artifactrepo/$CI_PIPELINE_ID/"        

Baking AMIs:
    stage: baking-amis
    image: ashwinbittu/amlinbase:latest
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Baking AMIs"       
        - aws sts get-caller-identity
        - git clone -b main https://gitlab.com/ashwinbittu/apps/stackApp.git
        - cd stackApp/iac/packer

        - /usr/bin/packer validate -var "app_layer=app" -var "source_ami=$ubuntu_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$app_userscript" -var "ssh_username=$ubuntu_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$ubuntu_owners" -var   "art_token=$ART_TOKEN" -var "build_number=$CI_PIPELINE_ID" -var "warfilename=target/$appname-$appver.war" template.ubuntu.pkr.hcl
        - /usr/bin/packer build    -var "app_layer=app" -var "source_ami=$ubuntu_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$app_userscript" -var "ssh_username=$ubuntu_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$ubuntu_owners"  -var   "art_token=$ART_TOKEN" -var "build_number=$CI_PIPELINE_ID" -var "warfilename=target/$appname-$appver.war" template.ubuntu.pkr.hcl
        - cp manifest.json app_img_manifest.json
        - app_ami_id=$(jq -r '.builds[-1].artifact_id' app_img_manifest.json | cut -d ":" -f2)
        - echo "app_ami_id-in baking->>"$app_ami_id
        - echo "app_ami_id=$app_ami_id" >> build.env   
                       
        #################  
              
        - /usr/bin/packer validate -var "app_layer=msg" -var "source_ami=$ubuntu_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$msg_userscript" -var "ssh_username=$ubuntu_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$ubuntu_owners"   -var   "art_token=$ART_TOKEN" -var "build_number=$CI_PIPELINE_ID" template.ubuntu.pkr.hcl
        - /usr/bin/packer build    -var "app_layer=msg" -var "source_ami=$ubuntu_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$msg_userscript" -var "ssh_username=$ubuntu_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$ubuntu_owners"  -var   "art_token=$ART_TOKEN" -var "build_number=$CI_PIPELINE_ID" template.ubuntu.pkr.hcl
        - cp manifest.json message_img_manifest.json
        - export mesg_ami_id=$(jq -r '.builds[-1].artifact_id' message_img_manifest.json | cut -d ":" -f2)                                        
        - echo "mesg_ami_id-baking->>"$mesg_ami_id     
        - echo "mesg_ami_id=$mesg_ami_id" >> build.env 
                   
        ################# 

        - /usr/bin/packer validate -var "app_layer=db" -var "source_ami=$amzlnx_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$db_userscript" -var "ssh_username=$amzlnx_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$amzlnx_owners" template.amzlinx2.pkr.hcl
        - /usr/bin/packer build    -var "app_layer=db" -var "source_ami=$amzlnx_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$db_userscript" -var "ssh_username=$amzlnx_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$amzlnx_owners" template.amzlinx2.pkr.hcl
        - cp manifest.json db_img_manifest.json
        - export db_ami_id=$(jq -r '.builds[-1].artifact_id' db_img_manifest.json | cut -d ":" -f2)                                        
        - echo "db_ami_id-baking->>"$db_ami_id 
        - echo "db_ami_id=$db_ami_id" >> build.env    
        
        #################         
        - /usr/bin/packer validate -var "app_layer=cache" -var "source_ami=$amzlnx_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$cache_userscript" -var "ssh_username=$amzlnx_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$amzlnx_owners" template.amzlinx2.pkr.hcl
        - /usr/bin/packer build    -var "app_layer=cache" -var "source_ami=$amzlnx_source_ami" -var "app_name=$app_name_stackapp" -var "instance_type=$instance_type" -var "script=$cache_userscript" -var "ssh_username=$amzlnx_ssh_username" -var "root-device-type=$ubuntu_root_device_type" -var "virtualization-type=$ubuntu_virtualization_type" -var "owners=$amzlnx_owners" template.amzlinx2.pkr.hcl
        - cp manifest.json cache_img_manifest.json
        - export cache_ami_id=$(jq -r '.builds[-1].artifact_id' cache_img_manifest.json | cut -d ":" -f2)                                        
        - echo "cache_ami_id-baking->>"$cache_ami_id  
        - echo "cache_ami_id=$cache_ami_id" >> build.env  
        
        #################
        - cat build.env                                    
    artifacts:
        reports:
            dotenv: stackApp/iac/packer/build.env

Network Infra Creation:
    stage: network-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:             
        - echo "Network Infra Creation"
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;                   
        - ./manageInfra.sh create network

Database Infra Creation:
    stage: database-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Database Infra Creation"                                      
        #- export db_ami_id="ami-09816318f11d5e51a"
        - echo "db_ami_id-in network->>"$db_ami_id        
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;                
        - ./manageInfra.sh create database

Caching Infra Creation:
    stage: caching-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Caching Infra Creation"                                      
        #- export cache_ami_id="ami-0cff53f76ae524ffb"
        - echo "cache_ami_id-in network->>"$cache_ami_id          
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;                 
        - ./manageInfra.sh create cache

Messaging Infra Creation:
    stage: messaging-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Messaging Infra Creation"                                                                         
        #- export mesg_ami_id="ami-0e287fa0b4c14707d"
        - echo "mesg_ami_id-in network->>"$mesg_ami_id        
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;               
        - ./manageInfra.sh create message

Application Infra Creation:
    stage: application-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Application Infra Creation"
        - echo "app_ami_id-in network->>"$app_ami_id
        #- export app_ami_id="ami-0a86e6ea650f6a9d2"
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;       
        - ./manageInfra.sh create application

Route53 Infra Creation:
    stage: route53-infra-creation
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "true"'    
    script:
        - echo "Route53 Infra Creation"
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;                
        - ./manageInfra.sh create route53

All Infra Destroy:
    stage: all-infra-destroy
    image: ashwinbittu/amlinbase:latest    
    rules:
        - if: '$infracreatemode == "false"'    
    script:
        - echo "All Infra Destroy"
        - git clone -b main https://gitlab.com/ashwinbittu/iac/stackapppipelines.git
        - cd stackapppipelines; chmod 777 *.*;               
        - ./manageInfra.sh destroy route53
        - ./manageInfra.sh destroy message
        - ./manageInfra.sh destroy cache
        - ./manageInfra.sh destroy database
        - ./manageInfra.sh destroy application
        - ./manageInfra.sh destroy network
                               
